# oc-dfg-clustering

Small library to cluster objects in ocel-files by their control-flow and their attributes. Therefor distances are calculated to later apply clustering on the corresponding distance matrix. 

The project consists of four components.
- library (code/ocel_clustering)
- cli version to use the library (code/cli.py)
- REST-API (code/json_api.py)
- Frontend to use the REST-API (frontend-rest-api)

# Library

```bash
code/ocel_clustering
```
The code offers different functions. In the following the main function ```ocel_cluster_by_objects(...)``` of the main module ```ocel_clustering.main``` is described briefly.

## Related work

The code relies on three major python packages: ```pandas```, ```numpy```, ```PM4Py```. To gain a further understanding of Object centric event logs (OCEL) and object centric direct follows graphs (oc-dfg) we recommend to check out ocel-standard.org/. OCEL is a format developed by the Process and Data Science Group by the Chair of Process and Data Science (PADS) (www.pads.rwth-aachen.de) at the Rheinisch-Westfälisch Technische Hochschule (RWTH) Aachen, Germany. The used package ```PM4Py``` (pm4py.fit.fraunhofer.de) is developed by the PADS group and the Frauenhofer Institute for Applied Information Technology (fit.fraunhofer.de).

## Core features

For a deeper understanding check out the generated documentation for the functions in all the modules in ocel_clustering.

### main

#### 

# CLI

For more information execute the following as the cli-version is self documenting:

For examples how to use the CLI check out the file code/sample-cli-execution.sh, there are some examples.
```powershell
python ./code/cli.py --help
```

# REST-API

For using the REST-API please execute the file json_api.py by either executing ```json_api_dev_run.bat``` for a development version (better error handling). Or execute ```json_api_prod_run.bat```.

Then a local server starts and you can use the following API-Endpoints. You may use tools like Postman to test the API. Many functions are also easily accessible via your browser.

For a full user friendly environment see the section __Web-Frontend__.

For information for the different parameters of the program ```json_api.py``` execute it and add the ```--help``` flag:

```bash
python code/json_api.py --help
```

In the following the possible http-routes are described:

## ocel-upload

### GET

```http
GET http://127.0.0.1:5000/ocel-upload
```
Returns a json with a list of already uploaded files.

### POST
```http
POST http://127.0.0.1:5000/ocel-upload
```
Using the key-field "file" (which is per default used in a file-upload formular in HTML) a new file is uploaded to the system. If the file already exists an error occurs.

## ocel-upload/\<filename\>

### DELETE
```http
DELETE http://127.0.0.1:5000/ocel-upload/<filename>
```
Deletes the file with the name 'filename'.

## ocel-cluster/\<filename\>

### POST
```http
POST http://127.0.0.1:5000/ocel-cluster/<filename>
```
Applies the core clustering algorithm for the file described via the filename.
Parameters of the algorithm can be described in the body of the request as json. The following is an example. 

```json
{
    "data": {
        "object-type": "customers",
        "mode": "all",
        "max-cluster-count": 4,
        "cluster-count": -1,
        "evaluate": "silhouette",
        "attr-weights": {
            "cflow": 2
        }
    }
}
```

A list of all possible parameters:
- _object-type_: type of object to apply the clustering algorithm on.
- _mode_: either "all" or "existence" which defines how the assignment of events to object clusters is done.
- _attr-weights_: A JSON-object to define the weights of attributes (including the pseudo-attribute "cflow" which described the **control**-flow of events corresponding to a object in the ocel-file).
- _cluster-algorithm_: Defines the clustering-technique to be used. Default is kmeans. possible is also agglomerative or spectral
- _max-cluster-count_: Defines the maximum cluster count. This value can be -1 for auto-maximum (which is the default value) or anything greater or equal to two. ATTENTION: This parameter highly affects the runtime! Be careful/patient with using high values.
- _cluster-count_: If its set to 2 or greater (default is -1 which means automatic) the cluster-count is fixed and max-cluster-count is ignored. 
- _evaluate_: Defines the mode the clustering is evaluated. Possible values are: 'silhouette', 'dbindex', 'derivative' 

## ocel-cluster/\<filename\>/graph?activity_threshold=\<x\>&edge_threshold=\<y\>
### GET
```http
GET http://127.0.0.1:5000/ocel-cluster/<filename>/graph?activity_threshold=<x>&edge_threshold=<y>
```
Returns a graph generated by discovering the ocel-file called _filename_. The minimum edge count and acitivity count for edges and acitivties to appear in the graph are defined by the paramters _activity\_threshold_ and _edge\_threshold_.

## ocel-cluster/\<filename\>/object-types
### GET
```http
GET http://127.0.0.1:5000/ocel-cluster/<filename>/object-types
```
Returns a list of all object types that appear in the ocel-file called _filename_.

## ocel-cluster/\<filename\>/object-types/\<objecttype\>/attributes
### GET
```http
GET http://127.0.0.1:5000/ocel-cluster/<filename>/object-types/<objecttype>/attributes
```
Returns a list of all non NaN attributes of objects that have the type _objecttype_ of the file _filename_.

## ocel-cluster/\<filename\>/object-types/\<objecttype\>/attributes
### GET
```http
GET http://127.0.0.1:5000/ocel-cluster/<filename>/object-types/<objecttype>/istance-count
```
Returns a number of objects that have the type _objecttype_ of the file _filename_.

## ocel-cluster/\<filename\>/clustering/\<clustering_id\>
### GET
```http
GET http://127.0.0.1:5000/ocel-cluster/<filename>/clustering/<clustering_id>
```

Returns the configuration of the clustering algorithm on the file called _filename_ for the clustering-run with the id _clustering\_id_.

## ocel-cluster/\<filename\>/clustering/\<clustering_id\>/clusters
### GET
```http
GET http://127.0.0.1:5000/ocel-cluster/<filename>/clustering/<clustering_id>/clusters
```

Returns the names and attributes of all clusters retrieved by applying the clustering algorithm on the file called _filename_ for the clustering-run with the id _clustering\_id_.

## ocel-cluster/\<filename\>/clustering/\<clustering_id\>/evaluation/plot
### GET
```http
GET http://127.0.0.1:5000/ocel-cluster/<filename>/clustering/<clustering_id>/evaluation/plot
```
Returns a plot that shows the fitness of the k's used by the clustering algorithm on the file called _filename_ for the clustering-run with the id _clustering\_id_.

## ocel-cluster/\<filename\>/clustering/\<clustering_id\>/evaluation/scatter
### GET
```http
GET http://127.0.0.1:5000/ocel-cluster/<filename>/clustering/<clustering_id>/evaluation/scatter
```
Returns a scatter-plot that shows the fitness of the selected k retrieved by the clustering algorithm on the file called _filename_ for the clustering-run with the id _clustering\_id_.

## ocel-cluster/\<filename\>/clustering/\<clustering_id\>/clusters/\<number\>
### GET
```http
GET http://127.0.0.1:5000/ocel-cluster/<filename>/clustering/<clustering_id>/custers/<number>
```
Returns the ocel-file generated for the specific cluster (_number_) retrieved by the clustering algorithm on the file called _filename_ for the clustering-run with the id _clustering\_id_.

## ocel-cluster/\<filename\>/clustering/\<clustering_id\>/clusters/\<number\>/graph?activity_threshold=\<x\>&edge_threshold=\<y\>
### GET
```http
GET http://127.0.0.1:5000/ocel-cluster/<filename>/clustering/<clustering_id>/custers/<number>/graph?activity_threshold=<x>&edge_threshold=<y>
```
Returns a graph generated by discovering the ocel-file generated for the specific cluster (_number_) retrieved by the clustering algorithm on the file called _filename_ for the clustering-run with the id _clustering\_id_. The minimum edge count and acitivity count for edges and acitivties to appear in the graph are defined by the paramters _activity\_threshold_ and _edge\_threshold_.

# Web-Frontend

You can find all the coding for the frontend in the directory ```frontend-rest-api```. The code uses the JSON-API version, which is supplied by the file ```code/json_api.py```. For more details about the API and how to run it see the section __JSON-API__.

To start the development instance run the file ```frontend_dev_run.bat```. If you would like to deploy the frontend to production use the file ```frontend_prod_build_and_run.bat```.

# Docker

MISSING

# Future work

## Core algorithm
- ocel_object_cluster_to_event_cluster: If the user selects an object-type which istances are rarly connected to events at all, the resulting ocels will be very small with little to no meaning about the overall process. An example might be the ocel.jsonocel file from the ocel-introduction website with object-type set to "packages".

## Frontend
- Currently image requests (and maybe other) are cached by the browser. This may lead to wrong graphical outputs. You may consider a graph of a file called ocel.oceljson if you delete it and upload another with the same name but different content. The browser might show the old visualization. This can also apply to clustered data if file content differs but filename is equal.
- While images are created and loaded (can take a while because large files have to be read, discover_ocdfg has to be applied, a graph has to be generated and the image has to be returned back to the client) the user does not see that anything is loading.

frontend: 3000, api: 5000
frontend: 80, api: 8080